// @ts-ignore
import cssLoader from "@hyext/compile";
// @ts-ignore
import upstreamTransformer from "metro-react-native-babel-transformer";

type transformerArgs = {
  filename: string;
  options: unknown;
  plugins: [string, object][];
  src: string;
};

module.exports = {
  transform: function (
    args: transformerArgs,
    registryPath: string,
    assetPlugins: unknown[]
  ) {
    let { src, filename, options, plugins = [] } = args;

    //处理业务代码
    if (filename.indexOf("node_modules") < 0) {
      if (filename.endsWith(".css") || filename.endsWith(".hycss")) {
        return upstreamTransformer.transform({
          src: cssLoader.feature.transformCss2Js(src, filename, options, plugins),
          filename,
          options,
          plugins,
        });
      }

      if (
        filename.endsWith(".js") ||
        filename.endsWith(".jsx") ||
        filename.endsWith(".tsx") ||
        filename.endsWith(".ts")
      ) {
        src = cssLoader.feature.transformStylesheet(src, filename, options, plugins);
      }
    } else {
      if (filename.endsWith(".css") || filename.endsWith(".hycss")) {
        return upstreamTransformer.transform({
          src: cssLoader.feature.transformCss2Js(src, filename, options, plugins),
          filename,
          options,
          plugins,
        });
      }
    }

    return upstreamTransformer.transform({ src, filename, options, plugins });
  },
};
